# CHANGELOG

binary-tools: JavaScript binary tools for any browser or environment.  
Copyright (c) 2023  Rafael da Silva Rocha.  
https://rochars.com/binary-tools

## 1.0.2
- Fix: Signed user-defined integers with bit lengths that are
  not multiple of 8 now work properly.
- Fix: Correctly checking for overflows when reading/unpacking
  used-defined types with bit lengths that are not multiple of
  8 (5-bit ints, 12-bit ints and so). The previous behaviour
  was to incorrectly clamp the results on overflow. The expected
  behaviour is to throw a RangeError and inform the start index
  of the incorrect value on the buffer.

## 1.0.1
- Fix: unpackTo() was not validating the input buffer length
  when 'safe' was set to true.
- Fix: unpack() was not validating the input buffer length
  when 'safe' was set to true.
- Fix: unpack() was reading NaN when input buffer didnt had
  enough bytes (size too small or index too high) and 'safe'
  was false. Now it ignores the unreadable bytes according to
  each type, like stated in the docs.
- Fix: unpackTo() was reading NaN when input buffer didnt had
  enough bytes (size too small or index too high) and 'safe'
  was false. Now it ignores the unreadable bytes according to
  each type, like stated in the docs.
- Fix: writeTo() was not validating output buffer size if
  output was a TypedArray. Now it throws a Bad buffer length
  error when output is TypedArray and size is not enough.

## 1.0.0
